/*************************************************************************
Title:		AVR-SUN
Author:		Uwe Nagel
Date:		05. Juli 2003
Compiler:	AVR-GCC 3.3
Hardware:	Any AVR with enough memory
			HD44780 compatible LCD text display
Copyright:
	Dieses Programm ist geistiges Eigentum des Autors.
	Nur die private, nicht kommerzielle Nutzung ist gestattet.
	Jegliche kommerzielle Nutzung bedarf der ausdrcklichen 
	Zustimmung des Autors.
**************************************************************************/


#include <stdlib.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <string.h>
#include <math.h>
#include <stdio.h>


typedef struct
	{	int8_t h;
		uint8_t m;
	} zeit_t;

zeit_t aufgang, untergang;

#define PY 0.0174532925199432957692369076848861
#define SIN(x) sin((x)*PY)
#define COS(x) cos((x)*PY)
#define TAN(x) tan((x)*PY)
#define ATAN(x) atan(x)/PY
#define ASIN(x) asin(x)/PY
#define ACOS(x) acos(x)/PY


void sun( int year, int month, int day, double longitude, double latitude, int rise, int localOffset, zeit_t* zeit );

void sun( int year, int month, int day, double longitude, double latitude, int rise, int localOffset, zeit_t* zeit  ){



double N = month + day + year;


double lngHour = longitude / 15;
double t;
	if( rise==1 ) 	t = N + (( 6 - lngHour) / 24);
        	else 	t = N + ((18 - lngHour) / 24);

double COSH = SIN(latitude);
	

zeit->h=floor( t );
zeit->m=floor( 60 * ( (int)COSH - zeit->h ));

}





int main(void)
{
char sss[16];

	sun( 2003, 7, 5, 8.558, 49.316 , 1, 2, &aufgang );
	sun( 2003, 7, 5, 8.558, 49.316 , 0, 2, &untergang );

	sprintf(sss,"sunrise %02d:%02d\n",aufgang.h,aufgang.m);
	sprintf(sss,"sunset  %02d:%02d\n",untergang.h,untergang.m);

	
	for(;;);

}
